Added "path" ability to -n option to enable ripping from a DVD folder location
authorAlan J. Pippin <ajp@pippins.net>
Tue, 19 May 2009 14:05:50 +0000 (08:05 -0600)
committerAlan J. Pippin <ajp@pippins.net>
Tue, 19 May 2009 14:05:50 +0000 (08:05 -0600)
Quote protected references to $logfile

rip_dvd

diff --git a/rip_dvd b/rip_dvd
index 363b52e56547140ce5822fad956f5eedb6dce998..4e37c54a9766a4250446430032fd79a6d512e7a9 100755 (executable)
--- a/rip_dvd
+++ b/rip_dvd
@@ -67,6 +67,7 @@ typeset dvdname=""
 typeset debug=""
 typeset dest=""
 typeset isofile=""
+typeset dvdpath=""
 typeset -i keep_intermediate_files=0
 typeset -i make_final_dest_vob=0
 typeset -i make_final_dest_iso=0
@@ -112,6 +113,7 @@ function usage() {
     echo >&2 "Options:"
     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
     echo >&2 "   -n <dvdname>  Specify what the name of the DVD is to process from $tmpdir"
+    echo >&2 "                 If it is a full path to a DVD folder, it will be ripped instead of $dev"
     echo >&2 "                 This is optional. If not specified, the dvd will be pulled from $dev"
     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
     echo >&2 "                 The default operation is non-mirror mode where only the main"
@@ -192,6 +194,18 @@ if [ -z "$dvdname" ]; then
   dvdname=`volname $dev | awk '{ print $1 }'`
   ripdvd=1
 else 
+  # check to see if dvdname is a full path to a real directory
+  # if it is, set dvdname and dvdpath appropriately
+  if [ -d "$dvdname" ]; then
+    dvdpath="$dvdname"
+    dvdname=`basename "$dvdname"`
+    if [ -z "$dvdname" ]; then
+     fatal_and_exit "-E- Unable to extract dvdname from path: $dvdpath"
+    fi
+    if [ ! -d "$dvdpath/VIDEO_TS" ]; then
+      fatal_and_exit "-E- You must supply a full path to a valid DVD folder with this option"
+    fi
+  fi
   ripdvd=0
 fi
 
@@ -236,10 +250,10 @@ cleanup() {
     [[ -e "$encodelog" ]] && rm -f "$encodelog"
     [[ -e "$dumplog" ]] && rm -f "$dumplog"
   else
-    [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a $logfile
-    [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a $logfile
-    [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a $logfile
-    [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a $logfile
+    [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
+    [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
+    [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
+    [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
   fi
   echo ""
 }
@@ -250,7 +264,7 @@ fatal_and_exit() {
   else
     msg=$1
   fi
-  echo -e 2>&1 "$msg" | tee -a $logfile
+  echo -e 2>&1 "$msg" | tee -a "$logfile"
   if [[ -n "$mailto" ]]; then
     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
   fi
@@ -264,24 +278,50 @@ trap cleanup EXIT
 ###############################################
 # processing functions
 function make_dvd_iso_image {
-  # load the CSS codes in the DVD drive 
-  lsdvd $dev >> "$logfile"
-  if [ $? != 0 ]; then
-    fatal_and_exit "-E- lsdvd $dev failed" 
-  fi
 
-  # read the DVD, ignoring/skipping CRC errors
   isofile="$1"
-  ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
+
+  # check to see if we have a dvdpath to rip from instead of $dev
+  if [ -z "$dvdpath" ]; then
+    # load the CSS codes in the DVD drive 
+    lsdvd $dev >> "$logfile"
+    if [ $? != 0 ]; then
+      fatal_and_exit "-E- lsdvd $dev failed" 
+    fi
+
+    # read the DVD, ignoring/skipping CRC errors
+    ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
+    if [ $? != 0 ]; then
+      fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
+    fi
+    cat "$ddrescuelog" >> "$logfile"
+  else
+    # rip from a path instead
+    make_dvd_iso_image_from_folder "$dvdpath" "$isofile"
+    if [ ! -s "$isofile" ]; then
+      fatal_and_exit "-E- Unable to make an iso image from the DVD folder: $dvdpath"
+    fi
+  fi
+}
+
+function make_dvd_iso_image_from_folder {
+  
+  src="$1"
+  dst="$2"
+  
+  echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
+
+  # make an iso image out of our directory
+  echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
+  mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
   if [ $? != 0 ]; then
-    fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
+    fatal_and_exit '-E- mkisofs -dvd-video "$src" | dd of="$dst" obs=32k seek=0 failed'
   fi
-  cat "$ddrescuelog" >> "$logfile"
 }
 
 function make_dvdbackup_folder_image {
   # extract the feature title from the DVD image
-  echo "-> Extracting feature title using dvdbackup" | tee -a $logfile
+  echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
   if [ $? != 0 ]; then
@@ -291,10 +331,10 @@ function make_dvdbackup_folder_image {
 
 function make_dvdauthor_folder_image {
   # create a new DVD video of the feature title
-  echo "-> Creating DVD video $dest/$dvdname" | tee -a $logfile
+  echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
-  cat $dvdauthorlog | grep -v "VOBU" >> $logfile
+  cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
 
   # There is a chance that dvdauthor won't like some of the VOBs.
   # We can't tell ahead of time which ones it will choke on. 
@@ -311,12 +351,12 @@ function make_dvdauthor_folder_image {
     if [[ ! -f "$badvob" ]]; then
       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
     fi
-    echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a $logfile
-    cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> $logfile 2>&1
+    echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
+    cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
     mv -f $badvob.fixed $badvob
     echo "-> Creating DVD video $dest/$dvdname"
     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
-    cat $dvdauthorlog | grep -v "VOBU" >> $logfile
+    cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
     grep -q "SCR moves" $dvdauthorlog
   done
 }
@@ -366,14 +406,14 @@ function create_main_vob_with_mplayer {
 
   # use mplayer to create the main VOB file
   remove_dumplog=$1
-  echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $dest/$dvdname.VOB" | tee -a $logfile
-  echo "   mplayer $lang_opts -dumpstream -dumpfile \"$dest/$dvdname.VOB\" -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> $logfile
+  echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $dest/$dvdname.VOB" | tee -a "$logfile"
+  echo "   mplayer $lang_opts -dumpstream -dumpfile \"$dest/$dvdname.VOB\" -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
   mplayer $lang_opts -dumpstream -dumpfile "$dest/$dvdname.VOB" -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
   if [ $? != 0 ]; then
-    cat $dumplog | grep -v "^A:" >> $logfile
+    cat $dumplog | grep -v "^A:" >> "$logfile"
     fatal_and_exit "-E- Mplayer Failed"
   fi
-  cat $dumplog | grep -v "^A:" >> $logfile
+  cat $dumplog | grep -v "^A:" >> "$logfile"
   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
 }
 
@@ -389,7 +429,7 @@ function get_audio_id_from_iso {
     grep -q "aid: $aid" $aidcheck
   done
   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
-  echo "-> Setting the audio stream ID to $aid" | tee -a $logfile
+  echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
   # mencoder default DVD audio track language selection (english)
   lang_opts="-aid $aid -alang en"
 }
@@ -397,16 +437,16 @@ function get_audio_id_from_iso {
 function get_crop_from_iso { 
   FRAMES=10000
   echo "-> Detecting black frame border crop value from ISO file"
-  echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> $logfile
+  echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
   [[ -e "md5sums" ]] && rm -f "md5sums"
   CROP=`cat $dumplog | grep CROP | tail -1`
-  echo "   Found crop value of $CROP" >> $logfile
+  echo "   Found crop value of $CROP" >> "$logfile"
   CROP=${CROP#* crop=}
   CROP=${CROP%%\).*}
   typeset -i CROPCHECK
   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
-  echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> $logfile
+  echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
   if [ -z "$CROP" ]; then
     fatal_and_exit "-E- Unable to extract CROP value from iso: $isofile"
   fi
@@ -430,7 +470,7 @@ function get_audio_id_from_vob {
     grep -q "Found audio stream: $aid" $aidcheck
   done
   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
-  echo "-> Setting the audio stream ID to $aid" | tee -a $logfile
+  echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
   # mencoder default DVD audio track language selection (english)
   lang_opts="-aid $aid -alang en"
 }
@@ -449,7 +489,7 @@ function check_vob_for_corrupted_start {
   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
     (( skip = skip + 5 ))
-    echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a $logfile
+    echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
     if [ $? != 0 ]; then
       fatal_and_exit "-E- Mencoder Failed"
@@ -459,7 +499,7 @@ function check_vob_for_corrupted_start {
   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
 
   # cat the giant VOB into mencoder to create a playable VOB file
-  cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$dest/$dvdname.VOB" >> $logfile 2>&1
+  cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$dest/$dvdname.VOB" >> "$logfile" 2>&1
   if [ $? != 0 ]; then
     fatal_and_exit "-E- Mencoder Failed"
   fi
@@ -477,7 +517,7 @@ function check_vob_for_completeness {
   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
-    echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a $logfile
+    echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
     create_main_vob_with_mplayer
     [[ -e "$dumplog" ]] && rm -f $dumplog
     DST_VOB_FILESIZE=$(stat -c%s "$dest/$dvdname.VOB")
@@ -496,10 +536,10 @@ function check_vob_for_too_many_video_packets {
   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
-  grep -q "Too many video packets in the buffer:" $logfile
+  grep -q "Too many video packets in the buffer:" "$logfile"
   if [ $? == 0 ]; then
     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
-    echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a $logfile
+    echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
     create_main_vob_with_mplayer
     grep -q "Too many video packets in the buffer:" $dumplog
     if [ $? == 0 ]; then
@@ -518,20 +558,20 @@ function check_vob_for_a52_crc_errors {
   # the "a52: CRC check failed" copy protection scheme.
   MAX_ERRORS=10
   ENDPOS=120
-  echo "-> Checking for a52 audio stream CRC errors" | tee -a $logfile
+  echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
   mplayer -endpos $ENDPOS -ao null -vo null "$dest/$dvdname.VOB" > $dumplog 2>&1
-  cat $dumplog | grep -v "^A:" >> $logfile
+  cat $dumplog | grep -v "^A:" >> "$logfile"
   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
   if [ $errors -gt $MAX_ERRORS ]; then
-    echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a $logfile
+    echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
     create_main_vob_with_mplayer
-    echo "-> Checking for a52 audio stream CRC errors" | tee -a $logfile
+    echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
     mplayer -endpos $ENDPOS -ao null -vo null "$dest/$dvdname.VOB" > $dumplog 2>&1
     if [ $? != 0 ]; then
-      cat $dumplog | grep -v "^A:" >> $logfile
+      cat $dumplog | grep -v "^A:" >> "$logfile"
       fatal_and_exit "-E- Mplayer Failed"
     fi
-    cat $dumplog | grep -v "^A:" >> $logfile
+    cat $dumplog | grep -v "^A:" >> "$logfile"
     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
     if [ $errors -gt $MAX_ERRORS ]; then
       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
@@ -552,8 +592,8 @@ function calculate_bitrate_from_target_size {
 function create_dvdauthor_dvd_xml_file {
   # make a dvdauthor xml menu file to create a valid DVD video from 
   # this script does a good job, but we'll still need to clean it up a bit after it runs
-  echo "-> Creating dvdauthor XML menu file" | tee -a $logfile
-  makexml -overwrite -dvd *.VOB -out dvd >> $logfile 2>&1
+  echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
+  makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
   if [ $? != 0 ]; then
     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
   fi
@@ -601,7 +641,7 @@ function create_dvdauthor_dvd_xml_file {
 
 function check_for_mplayer_dumpstream_incompatibility {
 
-  echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a $logfile
+  echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
 
   if [ ! -e "$dest/$dvdname.VOB" ]; then
     # mplayer dumpstream does not work on DVDs that obscure the feature title.
@@ -617,13 +657,13 @@ function check_for_mplayer_dumpstream_incompatibility {
     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
-        echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a $logfile
-        echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a $logfile
+        echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
+        echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
         invalid_feature_title=1
       else 
-        echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a $logfile
-        echo "-W- We still may not be able to autodetect the right feature title" | tee -a $logfile
-        echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a $logfile
+        echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
+        echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
+        echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
         use_mplayer_dumpstream=0
         invalid_feature_title=1
       fi
@@ -640,7 +680,7 @@ function check_for_mplayer_dumpstream_incompatibility {
     mencoder $mplayer_opts "$dest/$dvdname.VOB" -o "/dev/null" > $dumplog 2>&1
     grep -q "Too many audio packets in the buffer" $dumplog
     if [ $? == 0 ]; then
-      echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a $logfile
+      echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
       use_mplayer_dumpstream=0
       mplayer_dumpstream_incompatibility=1
     fi
@@ -656,18 +696,18 @@ function fill_mythvideo_metadata {
 
   # Make sure the fill mythvideo metadata option has been set to 1
   if [ $fill_mythvideo_metadata -eq 0 ]; then
-    echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a $logfile
+    echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
     return 0
   fi
 
   # If the fill mythvideo metadata script is present, run it
   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
-    echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a $logfile
-    fill_mythvideo_metadata.pl -N 0 -F "$filename" >> $logfile 2>&1
+    echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
+    fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
   else
-    echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a $logfile
-    echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a $logfile
+    echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
+    echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
   fi
 }
 
@@ -676,7 +716,7 @@ function remove_intermediate_vob_file {
   if [ $keep_intermediate_files -eq 0 ]; then
     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
   else
-    echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a $logfile
+    echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
   fi
 }
 
@@ -685,7 +725,7 @@ function remove_intermediate_iso_file {
   if [ $keep_intermediate_files -eq 0 ]; then
     [[ -e "$isofile" ]] && rm "$isofile"
   else
-    echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a $logfile
+    echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
   fi
 }
 
@@ -693,7 +733,7 @@ function remove_intermediate_dvdbackup_folder {
   if [ $keep_intermediate_files -eq 0 ]; then
     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
   else
-    echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a $logfile
+    echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
   fi
 }
 
@@ -718,7 +758,7 @@ if [ $mirror_mode -eq 1 ]; then
   eject -T $dev
 
   date=`date`
-  echo "$date DVD rip completed" | tee -a $logfile
+  echo "$date DVD rip completed" | tee -a "$logfile"
 
   if [[ -n "$mailto" ]]; then
     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
@@ -729,12 +769,20 @@ fi
 # Rip the DVD - Main Title Feature Only
 if [ $mirror_mode -eq 0 ]; then
 
+  # Rip image from DVD
   if [ $ripdvd -eq 1 ]; then
-    echo "-> Ripping DVD $dvdname to $dest" | tee -a $logfile
-
+    echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
     # use ddrescue to make an ISO image of the disk
     make_dvd_iso_image "$tmpdir/$dvdname.iso"
-    
+  fi
+
+  # Rip image from DVD path
+  if [ -n "$dvdpath" ]; then
+    echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
+    make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso"
+    if [ ! -s "$tmpdir/$dvdname.iso" ]; then
+      fatal_and_exit "-E- Unable to make an iso image from the DVD folder: $dvdpath"
+    fi
   fi
 
   # make sure our isofile value is set
@@ -745,7 +793,7 @@ if [ $mirror_mode -eq 0 ]; then
   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_avi -eq 1 ]; then
 
     if [ ! -e "$dest/$dvdname.VOB" ]; then
-      echo "-> Creating DVD video $dest/$dvdname.VOB" | tee -a $logfile
+      echo "-> Creating DVD video $dest/$dvdname.VOB" | tee -a "$logfile"
       
       # get the feature title from the ISO
       get_feature_title
@@ -806,12 +854,12 @@ if [ $mirror_mode -eq 0 ]; then
       remove_intermediate_iso_file
 
     else
-      echo "-> Skipping VOB creation. VOB DVD video already exists: $dest/$dvdname.VOB" | tee -a $logfile
+      echo "-> Skipping VOB creation. VOB DVD video already exists: $dest/$dvdname.VOB" | tee -a "$logfile"
     fi
 
     # transcode the DVD
     if [ $make_final_dest_avi -eq 1 ]; then
-      echo "-> Encoding the DVD video to an AVI file" | tee -a $logfile
+      echo "-> Encoding the DVD video to an AVI file" | tee -a "$logfile"
 
       # determine what our bitrate needs to be if a target size was specified instead
       calculate_bitrate_from_target_size        
@@ -867,28 +915,28 @@ if [ $mirror_mode -eq 0 ]; then
         for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
         do
           echo -e "   Encoding pass $PASS"
-          echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$dest/$dvdname.VOB\" -o \"$output_file\" >> $encodelog 2>&1" >> $logfile
+          echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$dest/$dvdname.VOB\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
           mencoder $CH_OPTS $mencoder_opts_for_pass "$dest/$dvdname.VOB" -o "$output_file" > $encodelog 2>&1
           mencoder_retval=$? 
           grep -q "\[channels\] Invalid" $encodelog
           if [ $? != 0 ]; then     
             break;
           else
-            echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> $logfile
+            echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
           fi
         done
         if [ $mencoder_retval != 0 ]; then
           fatal_and_exit "-E- Unhandled mencoder error"
         fi
         # Concatenate the encode log to our main log file, greping out unwanted lines
-        cat $encodelog | grep -v "Pos:" >> $logfile
+        cat $encodelog | grep -v "Pos:" >> "$logfile"
       done
 
       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
         [[ -e "$dest/$dvdname.VOB" ]] && rm -f "$dest/$dvdname.VOB";
         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
       else
-        echo "-> Keeping VOB file: $dest/$dvdname.VOB" | tee -a $logfile
+        echo "-> Keeping VOB file: $dest/$dvdname.VOB" | tee -a "$logfile"
         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
       fi
     fi
@@ -921,24 +969,20 @@ if [ $mirror_mode -eq 0 ]; then
   popd > /dev/null 2>&1
 
   if [ $make_final_dest_iso -eq 1 ]; then
-    echo "-> Creating ISO image of DVD video: $dest/$dvdname -> $dest/$dvdname.iso" | tee -a $logfile
 
     # make an iso image out of our directory
-    mkisofs -dvd-video "$dest/$dvdname" 2>> $logfile | dd of="$dest/$dvdname.iso" obs=32k seek=0 > /dev/null
-    if [ $? != 0 ]; then
-      fatal_and_exit '-E- mkisofs -dvd-video "$dest/$dvdname" | dd of="$dest/$dvdname.iso" obs=32k seek=0 failed'
-    fi
+    make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso"
    
     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
     if [ -s "$dest/$dvdname.iso" ]; then
       if [ $make_final_dest_folder -eq 0 ]; then
-        echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a $logfile
+        echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
         # remove the folder of the DVD image now that we have a .iso version of it
         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
       fi
     else
       # we created an empty iso file, remove it
-      echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a $logfile
+      echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
     fi
@@ -960,7 +1004,7 @@ if [ $mirror_mode -eq 0 ]; then
   [ $ripdvd -eq 1 ] && eject -T $dev
 
   date=`date`
-  echo "$date DVD rip completed" | tee -a $logfile
+  echo "$date DVD rip completed" | tee -a "$logfile"
 
   if [[ -n "$mailto" ]]; then
     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"